/**************************************************************************
*
* 96. [Unique Binary Search Trees](https://leetcode.com/problems/unique-binary-search-trees/)
*
* Given an integer n, return the number of structurally unique BST's (binary search trees)
* which has exactly n nodes of unique values from 1 to n.
*
* BST:
* - The left subtree of a node contains only nodes with keys lesser than the node’s key.
* - The right subtree of a node contains only nodes with keys greater than the node’s key.
* - The left and right subtree each must also be a binary search tree.
*
* 给出1..n的数字序列,问可以组成多少种二叉搜索树。
*
* 我们定义
* f[n] : 长度为n时组成的二叉搜索树。
* 根节点的情况共有n种,1, 2, 3, ..., n.
* 把每一种根节点的BST树计算出来,然后把所有根节点的情况加起来即为总的f[n].
*
* 由于二叉树的性质,取某个节点x作为root,左子树元素为 1 ~ x-1, 右子树的元素为 x+1 ~ n
* root:x 左子树元素个数:x-1, 右子树元素个数: n - x
* 现在我们来计算 root 为 x 时的BST数目,把左右子树的BST数目相乘即可.
* 左子树 1 ~ x-1, 根据定义,可用 f[x-1] 来表示 所有 1 ~ x-1 组成的BST.
*
* 左子树问题解决了,那右子树的 x+1 ~ n的这些数组成的BST如何计算呢?
* 根据二叉搜索树的性质,因为数字都是排序好的,其实 x+1 ~ n 共有n-x个元素,我们只需关注有多少个元素组成二叉搜索树就行了,
* 因此右子树对应的BST为 f[n-x],另一种考虑方法是平移右子树序列和1对其,则右子树序列变为 1 ~ n-x
*
* 因此root: x
* f[x] = f[x-1] * f[n-x]
*
* f[n] = sum(f[x-1] * f[n-x]), where x ~ (1, n) //把所有根节点的情况加起来
*
*
**************************************************************************/
int numTrees(int n) {
int *f = (int *)calloc(n + 1, sizeof(int));
f[0] = 1;
f[1] = 1;
for (int i = 2; i <= n; i++) {
for (int x = 1; x <= i; x++)
f[i] += f[x - 1] * f[i - x];
}
int ret = f[n];
free(f);
return ret;
}